<?php

/**
 * @file
 *
 * Utility file for Spectra Connect API operations
 */

namespace Drupal\spectra_connect;

use Drupal\spectra_connect\Entity\SpectraConnectEntity;

/**
 * Class SpectraConnectLoader
 * @package Drupal\spectra_connect
 *
 * TODO: add backtraces from /web/core/includes/errors.inc
 */
class SpectraConnectLoader {
  /**
   * @param $name
   * @return bool|\Drupal\Core\Entity\EntityInterface|SpectraConnectEntity|null
   * @throws \Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException
   * @throws \Drupal\Component\Plugin\Exception\PluginNotFoundException
   */
  public static function load_connector_by_name($name) {
    $c = \Drupal::entityTypeManager()->getStorage('spectra_connect_entity')->loadByProperties(['connector_name' => $name]);
    if (!empty($c)) {
      $id = array_keys($c)[0];
      return SpectraConnectEntity::load($id);
    }
    else {
      $message = 'No Spectra Connect Entity found for ' . $name . '.';
      \Drupal::logger('spectra_connect')->error($message);
      return FALSE;
    }
  }
}